
%global debug_package   %{nil}

%global provider        github
%global provider_tld    com
%global project         prometheus
%global repo            alertmanager
# https://github.com/prometheus/alertmanager
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          30af4d051b37ce817ea7e35b56c57a0e2ec9dbb0
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global build_gopath    %{_builddir}/%{repo}-%{shortcommit}-gopath
%global upstream_ver    0.14.0
%global rpm_ver         %(v=%{upstream_ver}; echo ${v//-/_})

Name:		golang-%{provider}-%{project}-%{repo}
Version:	%{rpm_ver}
Release:	1.git%{shortcommit}%{?dist}
Summary:	The Prometheus Alertmanager handles alerts sent by client applications such as the Prometheus server.
License:	ASL 2.0
URL:		https://prometheus.io/
Source0:	https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Patch0:         0001-Don-t-check-the-network-for-updates-to-promu.patch
Patch1:		0002-Strip-debug-info-from-binaries.patch

# promu build tool used for building prometheus
%global promu_repo      promu
%global promu_prefix    %{provider}.%{provider_tld}/%{project}/%{promu_repo}
%global promu_commit    74e548a5d08d8b4adfc37c7cf1ef7275a69a979b
%global promu_shortcmt  %(c=%{promu_commit}; echo ${c:0:7})
Source1:       https://%{promu_prefix}/archive/%{promu_commit}/%{promu_repo}-%{promu_shortcmt}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
# aarch64 promu-based builds FTBFS (#1487462)
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm} ppc64le s390x}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}

%package -n %{project}-%{repo}
Summary:        %{summary}
Provides:       prometheus-alertmanager = %{version}-%{release}

%description -n %{project}-%{repo}
%{summary}

%prep
%setup -q -T -n %{promu_repo}-%{promu_commit} -b 1
%setup -q -n %{repo}-%{commit}
%patch0 -p1
%patch1 -p1

%build
mkdir -p %{build_gopath}/src/%{provider}.%{provider_tld}/%{project}
# Link the extracted source directories to the expected GOPATH layout
ln -s ../../../../%{repo}-%{commit} %{build_gopath}/src/%{import_path}
ln -s ../../../../%{promu_repo}-%{promu_commit} %{build_gopath}/src/%{promu_prefix}

export GOPATH=%{build_gopath}
unset GOBIN
cd %{_builddir}/%{repo}-%{commit}
make build

%install
install -d %{buildroot}%{_bindir}
export PROM_BUILDDIR="%{_builddir}/%{repo}-%{commit}"
install -D -p -m 0755 ${PROM_BUILDDIR}/alertmanager %{buildroot}%{_bindir}/alertmanager
install -D -p -m 0755 ${PROM_BUILDDIR}/amtool %{buildroot}%{_bindir}/amtool
install -d %{buildroot}%{_sysconfdir}/prometheus
install -D -p -m 0644 ${PROM_BUILDDIR}/doc/examples/simple.yml %{buildroot}%{_sysconfdir}/prometheus/alertmanager.yml

%files -n %{project}-%{repo}
%license LICENSE NOTICE
%doc CHANGELOG.md CONTRIBUTING.md MAINTAINERS.md README.md
%config %{_sysconfdir}/prometheus/alertmanager.yml
%{_bindir}/alertmanager
%{_bindir}/amtool

%changelog
* Tue Feb 13 2018 Simon Pasquier <spasqui@redhat.com> - 0.14.0-1
- Upgrade to 0.14.0

* Wed Jan 31 2018 Paul Gier <pgier@redhat.com> - 0.13.0-1
- Upgrade to 0.13.0 and include amtool

* Thu Jan 18 2018 Simon Pasquier <spasquie@redhat.com> - 0.12.0-1
- Upgrade to 0.12.0

* Wed Jan 10 2018 Yaakov Selkowitz <yselkowi@redhat.com> - 0.9.1-3
- Rebuilt for ppc64le, s390x enablement

* Wed Nov 08 2017 Paul Gier <pgier@redhat.com> - 0.9.1-2
- upgrade to 0.9.1

* Fri Sep 01 2017 Paul Gier <pgier@redhat.com> - 0.8.0-2
- Strip debug and remove duplicate package

* Fri Aug 25 2017 Paul Gier <pgier@redhat.com> - 0.8.0-1
- First package for Openshift

